%define	name	pccts
%define	version	1.33mr32
%define	release	1
%define	serial	1
%define	prefix	/usr

Summary:	PCCTS - The Purdue Compiler Construction Tool Set
Name:		%{name}
Version:	%{version}
Release:	%{release}
Serial:		%{serial}
Prefix:		%{prefix}
Group:		Development/Tools
Copyright:	Public domain
Url:		http://www.polhode.com/pccts.html
Vendor:		Tom Moog <tmoog@polhode.com>
Source:		ftp://ftp.enteract.com/users/tmoog/pccts133mr.zip
Source1:	pccts.1
BuildRoot:	%{_tmppath}/%{name}-%{version}-root

%description
PCCTS is a set of public domain software tools designed to
facilitate  the  implementation  of  compilers  and  other
translation systems.  These tools currently include antlr,
dlg and support code.  In many ways, PCCTS is similar to a
highly integrated version of YACC [Joh78] and LEX [Les75];
where antlr (ANother Tool for Language Recognition) corresponds
to YACC and dlg (DFA-based Lexical analyzer Generator)
functions like LEX.  However, PCCTS  has  many  additional
features  which  make it easier to use for a wider range
of translation problems.

%prep
if [ -d pccts ]; then rm -r pccts; fi
unzip -q ${RPM_SOURCE_DIR}/pccts133mr.zip

%setup -DTn pccts

%build
export COPT="${RPM_OPT_FLAGS}";
if [ ! -d man ] ; then mkdir -p man/man1 ; fi
make MANDIR=man
make MANDIR=man manpages

%install
[ "${RPM_BUILD_ROOT}" != "/" ] && [ -d ${RPM_BUILD_ROOT} ] && rm -r ${RPM_BUILD_ROOT};
mkdir -p ${RPM_BUILD_ROOT}%{prefix}/bin \
	 ${RPM_BUILD_ROOT}%{prefix}/man/man1 \
	 ${RPM_BUILD_ROOT}%{prefix}/include/pccts

# Installing executables.
install -s -m 755 bin/antlr	${RPM_BUILD_ROOT}%{prefix}/bin
install -s -m 755 bin/dlg	${RPM_BUILD_ROOT}%{prefix}/bin
install -s -m 755 bin/genmk	${RPM_BUILD_ROOT}%{prefix}/bin
install -s -m 755 bin/sor	${RPM_BUILD_ROOT}%{prefix}/bin

# Installing man pages.
install -m 644 %{SOURCE1}	${RPM_BUILD_ROOT}%{prefix}/man/man1
install -m 644 man/man1/antlr.1	${RPM_BUILD_ROOT}%{prefix}/man/man1
install -m 644 man/man1/dlg.1	${RPM_BUILD_ROOT}%{prefix}/man/man1

## Done by RPM now.
##
## Compress man pages
## find ${RPM_BUILD_ROOT}%{prefix}/man -type f -print -exec gzip -9 {} \;

# Installing pccts header files, etc.
install -m 644 h/* ${RPM_BUILD_ROOT}%{prefix}/include/pccts

# Installing sorcerer header files, etc.
install -m 644 sorcerer/h/*.h ${RPM_BUILD_ROOT}%{prefix}/include/pccts

# Renaming sorcerer file to avoid conflicting with pccts
cp sorcerer/README README-sorcerer
cp sorcerer/UPDATES UPDATES-sorcerer

%clean
[ "${RPM_BUILD_ROOT}" != "/" ] && [ -d ${RPM_BUILD_ROOT} ] && rm -r ${RPM_BUILD_ROOT};

%files
%defattr(-,root,root)
%doc CHANGES* KNOWN_PROBLEMS.txt NOTES* README RIGHTS
%doc history.* README-sorcerer UPDATES-sorcerer
%{prefix}/bin/antlr
%{prefix}/bin/dlg
%{prefix}/bin/genmk
%{prefix}/bin/sor
%{prefix}/include/pccts
%{prefix}/man/*/*

%changelog
* Mon Mar  4 2002 Ryan Weaver <ryanw@falsehope.com>
  [pccts-1.33mr32-1]
- #310. (Changed in MR32) In C mode zzastPush was spelled zzastpush in one case.
- #309. (Changed in MR32) Renamed baseName because of VMS name conflict
- #308. (Changed in MR32) Used "template" as name of formal in C routine

* Thu Oct  4 2001 Ryan Weaver <ryanw@falsehope.com>
  [pccts-1.33mr31-1]
- #307. (MR31) Compiler dependent bug in function prototype generation

* Tue Oct  2 2001 Ryan Weaver <ryanw@falsehope.com>
  [pccts-1.33mr30-1]
- #306. (MR30) Validating predicate following a token
- #305. (MR30) Alternatives with guess blocks inside (...)* blocks.
- #304. (MR30) Crash when mismatch between output value counts.
- #303. (MR30) DLGLexerBase::replchar
- #302. (MR28) Fix significant problems in initial release of MR27.
- #301. (MR27) Default tab stops set to 2 spaces.
- #299. (MR27) Don't warn if k=1 and semantic predicate missing LT(i)
- #298. (MR27) Removed "register" for lastpos in dlgauto.c zzgettok
- #297. (MR27) Incorrect prototypes when used with classic C
- #296. (MR27) Complex return types in rules.
- #295. (MR27) Extra ";" following zzGUESS_DONE sometimes.
- #294. (MR27) Infinite loop in antlr for nested blocks
- #293. (MR27) Sorcerer optimization of _t->type()

* Wed Aug  1 2001 Ryan Weaver <ryanw@falsehope.com>
  [pccts-1.33mr25-1]
- #292. (Changed in MR25)
  WARNING:  Item #267 changes the signature of methods in the AST class.
  *** Be sure to revise your AST functions of the same name  ***

* Fri Jun 29 2001 Ryan Weaver <ryanw@falsehope.com>
  [pccts-1.33mr24-1]
- #291. Fix to serious code generation error in MR23 for (...)+ block.

* Thu Jun 28 2001 Ryan Weaver <ryanw@falsehope.com>
  [pccts-1.33mr23-1]
- #290. Item #247 describes a change in the way {...} blocks
        handled an error. The current change restores the
        behavior prior to #247 when parser exceptions are
        present, but retains the revised behavior otherwise.
- #289. Bug in matching complement of a #tokclass
- #288. #errclass not restricted to choice points
- #287. Print name for #tokclass
- #286. Makefile change to use of cd
- #285. Check for null pointers in some dlg structures
- #284. Allow #tokclass in #errclass definitions
- #283. Option -tmake invoke's parser's tmake 
- #282. Initialization error for DBG_REFCOUNTTOKEN
- #281. Addition of -noctor option for Sorcerer
- #280. Syntax error message for EOF token
- #279. Exception groups
- #278. makefile changes
- #277. Change in macro for failed semantic predicates
- #276. Addition of return value initialization syntax
- #275. Addition of -nopurify option to antlr
- #274. DLexer.cpp renamed to DLexer.h
        ATokPtr.cpp renamed to ATokPtrImpl.h
- #273. Default win32 library changed to multi-threaded DLL
- #272. Failed semantic predicate reported via virtual function
- #271. Warning for LT(i), LATEXT(i) in token match actions
- #270. Removed static objects from PCCTSAST.cpp
- #269. dlg output for initializing static array
- #268. syn() routine output when k > 1
- #267. AST traversal functions client data argument
- #266. virtual function printMessage()
- #265. Remove "labase++" in C++ mode
- #264. Complete rewrite of ParserBlackBox.h
- #263. -preamble and -preamble_first rescinded
- #262. Crash with -alpha option during traceback
- #261. Defer token fetch for C++ mode

* Wed Mar  1 2000 Ryan Weaver <ryanw@infohwy.com>
  [pccts-1.33mr22-1]
- #261. Defer token fetch for C++ mode
- #260. Raise default lex buffer size from 8,000 to 32,000 bytes.
- #259. Default function arguments in C++ mode.
- #258. Using a base class for your parser.

* Thu Feb 10 2000 Ryan Weaver <ryanw@infohwy.com>
  [pccts-1.33mr21a-1]
- #257. Removed dlg statement that -i has no effect in C++ mode.
- #256. Malformed syntax graph causes crash after error message.
- #255. ParserBlackBox(FILE* f) 
- #254. Reporting syntax error at end-of-file when using exceptions

* Sat Jan 29 2000 Ryan Weaver <ryanw@infohwy.com>
  [pccts-1.33mr21-1]
- #253. Generation of block preamble (-preamble and -preamble_first)
- #252. Check for null pointer in trace routine
- #251. Changes to #define zzTRACE_RULES
- #250. Option for EXPERIMENTAL change to error sets for blocks
- #249. Changes for DEC/VMS systems
- #248. Generate symbol for first set of an alternative
- #247. Misleading error message on syntax error for optional elements.
- #246. Use of $(MAKE) for calls to make
- #245. Changes to genmk
- #244. Rename variable "not" in antlr.g
- #243. Replace recursion with iteration in zzfree_ast
- #242. LineInfoFormatStr
- #241. Changed macro PURIFY to a no-op
- #240. sorcerer/h/sorcerer.h _MATCH and _MATCHRANGE
- #239. C++ mode AParser::traceGuessFail
- #238. Namespace version #include files
- #237. ParserBlackBox(FILE*)
- #236. tmake now reports down pointer problem
- #235. Made ANTLRParser::resynch() virtual

* Wed Aug 11 1999 Ryan Weaver <ryanw@infohwy.com>
  [pccts-1.33mr20-2]
- #234. Implicit int for function return value

* Mon Aug  9 1999 Ryan Weaver <ryanw@infohwy.com>
- Including pccts.1 manpage from 1.33mr19. Seems to be missing
  from 1.33mr20

  [pccts-1.33mr20-1]
- #233. Converted to MSVC 6.0
- #232. Make setwd bit vectors protected in parser.h
- #231. Error in token buffer debug code.
- #230. Fixed problem with #define for -gd option
- #229. Additional "const" for literals
- #228. dlg crashes on "()"
- #227. Array overwrite
- #226. -pedantic conformance
- #225. AST stack adjustment in C mode
- #224. LL(1) and LL(2) with #pragma approx
- #223. Addition of IBM_VISUAL_AGE directory
- #222. Replace __STDC__ with __USE_PROTOS
- #221. Added #include for DLexerBase.h to PBlackBox.

* Fri Apr 23 1999 Ryan Weaver <ryanw@infohwy.com>
  [pccts-1.33mr19-1]
- #220. strcat arguments reversed in #pred parse
- #219. C Mode routine zzfree_ast
- #218. Changes to support unsigned char in C mode
- #217. Error message when dlg -i and -CC options selected
- #216. Defer token fetch for C++ mode
- #215. Addition of reset() to DLGLexerBase
- #214. C mode: Adjust AST stack pointer at exit

* Mon Mar  1 1999 Ryan Weaver <ryanw@infohwy.com>
  [pccts-1.33mr18-2]
- PCCTS Webpage and email address change reflected in RPM header now.

* Fri Jan 22 1999 Ryan Weaver <ryanw@infohwy.com>
  [pccts-1.33mr18-1]
- Modified SPEC for Red Hat Contrib|Net
- #213. (Changed in MR18)  Fatal error with -mrhoistk (k>1 hoisting)

* Mon Jan 18 1999 Ryan Weaver <ryanw@infohwy.com>
  [pccts-1.33mr17-2]
- Fixed header installation.

* Mon Jan  4 1999 Ryan Weaver <ryanw@infohwy.com>
  [pccts-1.33mr17-1]
- #212. (Changed in MR17)  Mac related changes by Kenji Tanaka

* Wed Dec 16 1998 Ryan Weaver <ryanw@infohwy.com>
- Updated to 1.33 Maintainance Release 16a
- Including sor and sorcerer header files.

- #211. (Changed in MR16a)  C++ style comment in dlg
- #210. (Changed in MR16a)  Sor accepts \r\n, \r, or \n for end-of-line

* Fri Dec 11 1998 Ryan Weaver <ryanw@infohwy.com>
- Updated to 1.33 Maintainance Release 16

- #209. (Changed in MR16) Name of files changed.
- #208. (Changed in MR16) Change in use of pccts #include files
- #207. (Changed in MR16) dlg reports an invalid range for: [\0x00-\0xff]
- #206. (Changed in MR16) Free zzFAILtext in ANTLRParser destructor
- #205. (Changed in MR16) DLGStringReset argument now const

* Mon Mar 23 1998 Elliot Lee <sopwith@cuc.edu> 1.33-4
- Include header files

* Mon Mar 23 1998 Elliot Lee <sopwith@cuc.edu> 1.33-3
- Repackage for glibc
